import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChild, inject, input, TemplateRef, ViewEncapsulation, } from "@angular/core";
import { SdBusyContainerControl } from "../controls/sd-busy-container.control";
import { SdDockContainerControl } from "../controls/sd-dock-container.control";
import { SdDockControl } from "../controls/sd-dock.control";
import { SdPaneControl } from "../controls/sd-pane.control";
import { SdTopbarContainerControl } from "../controls/sd-topbar-container.control";
import { SdTopbarControl } from "../controls/sd-topbar.control";
import { SdShowEffectDirective } from "../directives/sd-show-effect.directive";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { SdAppStructureProvider } from "../providers/sd-app-structure.provider";
import { SdActivatedModalProvider } from "../providers/sd-modal.provider";
import { $computed } from "../utils/bindings/$computed";
import { useCurrentPageCodeSignal } from "../utils/signals/use-current-page-code.signal";
import { useFullPageCodeSignal } from "../utils/signals/use-full-page-code.signal";
import { useViewTypeSignal } from "../utils/signals/use-view-type.signal";
import { transformBoolean } from "../utils/type-tramsforms";
import { FaIconComponent } from "@fortawesome/angular-fontawesome";
import { injectParent } from "../utils/injections/inject-parent";
import * as i0 from "@angular/core";
const _c0 = ["pageTopbar"];
const _c1 = ["controlTool"];
const _c2 = ["content"];
const _c3 = ["modalBottom"];
function SdBaseContainerControl_Conditional_1_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-pane", 1);
    i0.ɵɵelement(1, "br")(2, "fa-icon", 2)(3, "br")(4, "br");
    i0.ɵɵtext(5);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r0.icons.triangleExclamation)("fixedWidth", true);
    i0.ɵɵadvance(3);
    i0.ɵɵtextInterpolate1(" '", ctx_r0.modalOrPageTitle(), "'\uC5D0 \uB300\uD55C \uC0AC\uC6A9\uAD8C\uD55C\uC774 \uC5C6\uC2B5\uB2C8\uB2E4. \uC2DC\uC2A4\uD15C \uAD00\uB9AC\uC790\uC5D0\uAC8C \uBB38\uC758\uD558\uC138\uC694. ");
} }
function SdBaseContainerControl_Conditional_1_Conditional_1_ng_template_4_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_1_Conditional_1_ng_template_6_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_1_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-topbar-container")(1, "sd-topbar")(2, "h4");
    i0.ɵɵtext(3);
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(4, SdBaseContainerControl_Conditional_1_Conditional_1_ng_template_4_Template, 0, 0, "ng-template", 3);
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(5, "sd-pane", 4);
    i0.ɵɵtemplate(6, SdBaseContainerControl_Conditional_1_Conditional_1_ng_template_6_Template, 0, 0, "ng-template", 3);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(3);
    i0.ɵɵtextInterpolate(ctx_r0.modalOrPageTitle());
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.pageTopbarTemplateRef() ?? null);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.contentTemplateRef());
} }
function SdBaseContainerControl_Conditional_1_Conditional_2_ng_template_2_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_1_Conditional_2_Conditional_3_ng_template_1_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_1_Conditional_2_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-dock", 5);
    i0.ɵɵtemplate(1, SdBaseContainerControl_Conditional_1_Conditional_2_Conditional_3_ng_template_1_Template, 0, 0, "ng-template", 3);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.modalBottomTemplateRef() ?? null);
} }
function SdBaseContainerControl_Conditional_1_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-dock-container")(1, "sd-pane", 4);
    i0.ɵɵtemplate(2, SdBaseContainerControl_Conditional_1_Conditional_2_ng_template_2_Template, 0, 0, "ng-template", 3);
    i0.ɵɵelementEnd();
    i0.ɵɵconditionalCreate(3, SdBaseContainerControl_Conditional_1_Conditional_2_Conditional_3_Template, 2, 1, "sd-dock", 5);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.contentTemplateRef());
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r0.modalBottomTemplateRef() ? 3 : -1);
} }
function SdBaseContainerControl_Conditional_1_Conditional_3_Conditional_1_ng_template_1_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_1_Conditional_3_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-dock");
    i0.ɵɵtemplate(1, SdBaseContainerControl_Conditional_1_Conditional_3_Conditional_1_ng_template_1_Template, 0, 0, "ng-template", 3);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.controlToolTemplateRef() ?? null);
} }
function SdBaseContainerControl_Conditional_1_Conditional_3_ng_template_3_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_1_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-dock-container");
    i0.ɵɵconditionalCreate(1, SdBaseContainerControl_Conditional_1_Conditional_3_Conditional_1_Template, 2, 1, "sd-dock");
    i0.ɵɵelementStart(2, "sd-pane", 4);
    i0.ɵɵtemplate(3, SdBaseContainerControl_Conditional_1_Conditional_3_ng_template_3_Template, 0, 0, "ng-template", 3);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r0.controlToolTemplateRef() ? 1 : -1);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.contentTemplateRef());
} }
function SdBaseContainerControl_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵconditionalCreate(0, SdBaseContainerControl_Conditional_1_Conditional_0_Template, 6, 3, "sd-pane", 1)(1, SdBaseContainerControl_Conditional_1_Conditional_1_Template, 7, 3, "sd-topbar-container")(2, SdBaseContainerControl_Conditional_1_Conditional_2_Template, 4, 2, "sd-dock-container")(3, SdBaseContainerControl_Conditional_1_Conditional_3_Template, 4, 2, "sd-dock-container");
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵconditional(ctx_r0.restricted() ? 0 : ctx_r0.currViewType() === "page" ? 1 : ctx_r0.currViewType() === "modal" ? 2 : 3);
} }
export class SdBaseContainerControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.#sdActivatedModal = inject(SdActivatedModalProvider, { optional: true });
        this.#sdAppStructure = inject(SdAppStructureProvider);
        this.#parent = injectParent();
        this.#fullPageCode = useFullPageCodeSignal();
        this.#currPageCode = useCurrentPageCodeSignal();
        this.pageTopbarTemplateRef = contentChild("pageTopbar", { read: TemplateRef });
        this.controlToolTemplateRef = contentChild("controlTool", { read: TemplateRef });
        this.contentTemplateRef = contentChild.required("content", { read: TemplateRef });
        this.modalBottomTemplateRef = contentChild("modalBottom", { read: TemplateRef });
        this.#parentViewType = useViewTypeSignal(() => this.#parent);
        this.viewType = input();
        this.currViewType = $computed(() => this.viewType() ?? this.#parentViewType());
        this.modalOrPageTitle = $computed(() => this.#sdActivatedModal?.modalComponent()?.title() ??
            this.#sdAppStructure.getTitleByFullCode(this.#currPageCode?.() ?? this.#fullPageCode()));
        this.initialized = input.required({ transform: transformBoolean });
        this.restricted = input(false, { transform: transformBoolean });
        this.busy = input(false, { transform: transformBoolean });
        this.busyMessage = input();
    }
    #sdActivatedModal;
    #sdAppStructure;
    #parent;
    #fullPageCode;
    #currPageCode;
    #parentViewType;
    static { this.ɵfac = function SdBaseContainerControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdBaseContainerControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdBaseContainerControl, selectors: [["sd-base-container"]], contentQueries: function SdBaseContainerControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.pageTopbarTemplateRef, _c0, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.controlToolTemplateRef, _c1, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.contentTemplateRef, _c2, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.modalBottomTemplateRef, _c3, 5, TemplateRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance(4);
        } }, inputs: { viewType: [1, "viewType"], initialized: [1, "initialized"], restricted: [1, "restricted"], busy: [1, "busy"], busyMessage: [1, "busyMessage"] }, decls: 2, vars: 3, consts: [[3, "busy", "message"], ["sd-show-effect", "", 1, "tx-theme-grey-light", "p-xxl", "tx-center"], ["size", "5x", 3, "icon", "fixedWidth"], [3, "ngTemplateOutlet"], ["sd-show-effect", ""], ["position", "bottom"]], template: function SdBaseContainerControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-busy-container", 0);
            i0.ɵɵconditionalCreate(1, SdBaseContainerControl_Conditional_1_Template, 4, 1);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("busy", ctx.busy())("message", ctx.busyMessage());
            i0.ɵɵadvance();
            i0.ɵɵconditional(ctx.initialized() ? 1 : -1);
        } }, dependencies: [SdPaneControl,
            FaIconComponent,
            SdTopbarContainerControl,
            SdTopbarControl,
            SdBusyContainerControl,
            NgTemplateOutlet,
            SdDockContainerControl,
            SdDockControl,
            SdShowEffectDirective], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdBaseContainerControl, [{
        type: Component,
        args: [{
                selector: "sd-base-container",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [
                    SdPaneControl,
                    FaIconComponent,
                    SdTopbarContainerControl,
                    SdTopbarControl,
                    SdBusyContainerControl,
                    NgTemplateOutlet,
                    SdDockContainerControl,
                    SdDockControl,
                    SdShowEffectDirective,
                ],
                template: `
    <sd-busy-container [busy]="busy()" [message]="busyMessage()">
      @if (initialized()) {
        @if (restricted()) {
          <sd-pane class="tx-theme-grey-light p-xxl tx-center" sd-show-effect>
            <br />
            <fa-icon [icon]="icons.triangleExclamation" [fixedWidth]="true" size="5x" />
            <br />
            <br />
            '{{ modalOrPageTitle() }}'에 대한 사용권한이 없습니다. 시스템 관리자에게 문의하세요.
          </sd-pane>
        } @else if (currViewType() === "page") {
          <sd-topbar-container>
            <sd-topbar>
              <h4>{{ modalOrPageTitle() }}</h4>

              <ng-template [ngTemplateOutlet]="pageTopbarTemplateRef() ?? null" />
            </sd-topbar>

            <sd-pane sd-show-effect>
              <ng-template [ngTemplateOutlet]="contentTemplateRef()" />
            </sd-pane>
          </sd-topbar-container>
        } @else if (currViewType() === "modal") {
          <sd-dock-container>
            <sd-pane sd-show-effect>
              <ng-template [ngTemplateOutlet]="contentTemplateRef()" />
            </sd-pane>

            @if (modalBottomTemplateRef()) {
              <sd-dock position="bottom">
                <ng-template [ngTemplateOutlet]="modalBottomTemplateRef() ?? null" />
              </sd-dock>
            }
          </sd-dock-container>
        } @else {
          <sd-dock-container>
            @if (controlToolTemplateRef()) {
              <sd-dock>
                <ng-template [ngTemplateOutlet]="controlToolTemplateRef() ?? null" />
              </sd-dock>
            }

            <sd-pane sd-show-effect>
              <ng-template [ngTemplateOutlet]="contentTemplateRef()" />
            </sd-pane>
          </sd-dock-container>
        }
      }
    </sd-busy-container>
  `,
            }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdBaseContainerControl, { className: "SdBaseContainerControl", filePath: "packages/sd-angular/src/advanced/sd-base-container.control.ts", lineNumber: 98 }); })();
//# sourceMappingURL=sd-base-container.control.js.map