import { Signal, TemplateRef } from "@angular/core";
import { SdFormControl } from "../../controls/sd-form.control";
import { TSdViewType } from "../../utils/signals/use-view-type.signal";
import { DateTime } from "@simplysm/sd-core-common";
import { ISdModal } from "../../providers/sd-modal.provider";
import * as i0 from "@angular/core";
export declare class SdDataDetailControl {
    protected readonly icons: import("../../providers/sd-angular-config.provider").ISdAngularIcon;
    parent: AbsSdDataDetail<any, boolean>;
    formCtrl: Signal<SdFormControl | undefined>;
    contentTemplateRef: Signal<TemplateRef<any>>;
    toolTemplateRef: Signal<TemplateRef<any> | undefined>;
    prevTemplateRef: Signal<TemplateRef<any> | undefined>;
    nextTemplateRef: Signal<TemplateRef<any> | undefined>;
    onRefreshButtonClick(): Promise<void>;
    onSubmitButtonClick(): void;
    onSubmit(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdDataDetailControl, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdDataDetailControl, "sd-data-detail", never, {}, {}, ["contentTemplateRef", "toolTemplateRef", "prevTemplateRef", "nextTemplateRef"], never, true, never>;
}
export declare abstract class AbsSdDataDetail<T extends object | undefined, R = boolean> implements ISdModal<R> {
    #private;
    restricted?: Signal<boolean>;
    readonly?: Signal<boolean>;
    isNew?: Signal<boolean>;
    dataInfo?: Signal<ISdDataDetailDataInfo>;
    abstract load(): Promise<T> | T;
    toggleDelete?(del: boolean): Promise<R> | R;
    submit?(): Promise<R> | R;
    viewType: import("@angular/core").InputSignal<TSdViewType | undefined>;
    currViewType: Signal<TSdViewType>;
    busyCount: import("../../utils/bindings/$signal").SdWritableSignal<number>;
    initialized: import("../../utils/bindings/$signal").SdWritableSignal<boolean>;
    close: import("@angular/core").OutputEmitterRef<R>;
    data: import("../../utils/bindings/$signal").SdWritableSignal<T>;
    constructor();
    checkIgnoreChanges(): boolean;
    doRefresh(): Promise<void>;
    refresh(): Promise<void>;
    doToggleDelete(del: boolean): Promise<void>;
    doSubmit(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<AbsSdDataDetail<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AbsSdDataDetail<any, any>, never, never, { "viewType": { "alias": "viewType"; "required": false; "isSignal": true; }; }, { "close": "close"; }, never, never, true, never>;
}
export interface ISdDataDetailDataInfo {
    isDeleted?: boolean;
    lastModifiedAt?: DateTime;
    lastModifiedBy?: string;
}
