import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChild, Directive, effect, HostListener, inject, input, output, reflectComponentType, TemplateRef, viewChild, ViewEncapsulation, } from "@angular/core";
import { TXT_CHANGE_IGNORE_CONFIRM } from "../../commons";
import { SdButtonControl } from "../../controls/sd-button.control";
import { SdFormControl } from "../../controls/sd-form.control";
import { SdAngularConfigProvider } from "../../providers/sd-angular-config.provider";
import { SdToastProvider } from "../../providers/sd-toast.provider";
import { $computed } from "../../utils/bindings/$computed";
import { $obj } from "../../utils/bindings/wrappers/$obj";
import { setupCanDeactivate } from "../../utils/setups/setup-can-deactivate";
import { useViewTypeSignal } from "../../utils/signals/use-view-type.signal";
import { SdBaseContainerControl } from "../sd-base-container.control";
import { FormatPipe } from "../../pipes/format.pipe";
import { SdSharedDataProvider } from "../shared-data/sd-shared-data.provider";
import { FaIconComponent } from "@fortawesome/angular-fontawesome";
import { $signal } from "../../utils/bindings/$signal";
import { injectParent } from "../../utils/injections/inject-parent";
import { SdTopbarMenuControl } from "../../controls/sd-topbar-menu.control";
import { SdTopbarMenuItemControl } from "../../controls/sd-topbar-menu-item.control";
import * as i0 from "@angular/core";
const _c0 = ["content"];
const _c1 = ["tool"];
const _c2 = ["prev"];
const _c3 = ["next"];
const _c4 = ["formCtrl"];
function SdDataDetailControl_Conditional_1_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-topbar-menu")(1, "sd-topbar-menu-item", 6);
    i0.ɵɵlistener("click", function SdDataDetailControl_Conditional_1_ng_template_0_Template_sd_topbar_menu_item_click_1_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onSubmitButtonClick()); });
    i0.ɵɵelement(2, "fa-icon", 7);
    i0.ɵɵtext(3, " \uC800\uC7A5 ");
    i0.ɵɵelementStart(4, "small");
    i0.ɵɵtext(5, "(CTRL+S)");
    i0.ɵɵelementEnd()()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r1.icons.save)("fixedWidth", true);
} }
function SdDataDetailControl_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataDetailControl_Conditional_1_ng_template_0_Template, 6, 2, "ng-template", null, 1, i0.ɵɵtemplateRefExtractor);
} }
function SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Conditional_6_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 13);
    i0.ɵɵlistener("click", function SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Conditional_6_Conditional_0_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r4); const ctx_r1 = i0.ɵɵnextContext(5); return i0.ɵɵresetView(ctx_r1.parent.doToggleDelete(false)); });
    i0.ɵɵtext(1, "\uBCF5\uAD6C");
    i0.ɵɵelementEnd();
} }
function SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Conditional_6_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r5 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 14);
    i0.ɵɵlistener("click", function SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Conditional_6_Conditional_1_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r5); const ctx_r1 = i0.ɵɵnextContext(5); return i0.ɵɵresetView(ctx_r1.parent.doToggleDelete(true)); });
    i0.ɵɵtext(1, "\uC0AD\uC81C");
    i0.ɵɵelementEnd();
} }
function SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Conditional_6_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵconditionalCreate(0, SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Conditional_6_Conditional_0_Template, 2, 0, "sd-button", 11)(1, SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Conditional_6_Conditional_1_Template, 2, 0, "sd-button", 12);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(4);
    i0.ɵɵconditional(ctx_r1.parent.dataInfo && ctx_r1.parent.dataInfo().isDeleted ? 0 : 1);
} }
function SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 8)(1, "sd-button", 10);
    i0.ɵɵlistener("click", function SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Template_sd_button_click_1_listener() { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.onSubmitButtonClick()); });
    i0.ɵɵelement(2, "fa-icon", 7);
    i0.ɵɵtext(3, " \uC800\uC7A5 ");
    i0.ɵɵelementStart(4, "small");
    i0.ɵɵtext(5, "(CTRL+S)");
    i0.ɵɵelementEnd()();
    i0.ɵɵconditionalCreate(6, SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Conditional_6_Template, 2, 1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r1.icons.save)("fixedWidth", true);
    i0.ɵɵadvance(4);
    i0.ɵɵconditional((!ctx_r1.parent.isNew || !ctx_r1.parent.isNew()) && ctx_r1.parent.toggleDelete ? 6 : -1);
} }
function SdDataDetailControl_Conditional_2_ng_template_0_Conditional_1_ng_template_1_Template(rf, ctx) { }
function SdDataDetailControl_Conditional_2_ng_template_0_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 9);
    i0.ɵɵtemplate(1, SdDataDetailControl_Conditional_2_ng_template_0_Conditional_1_ng_template_1_Template, 0, 0, "ng-template", 15);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r1.toolTemplateRef() ?? null);
} }
function SdDataDetailControl_Conditional_2_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵconditionalCreate(0, SdDataDetailControl_Conditional_2_ng_template_0_Conditional_0_Template, 7, 3, "div", 8);
    i0.ɵɵconditionalCreate(1, SdDataDetailControl_Conditional_2_ng_template_0_Conditional_1_Template, 2, 1, "div", 9);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵconditional(!(ctx_r1.parent.readonly == null ? null : ctx_r1.parent.readonly()) ? 0 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.toolTemplateRef() != null ? 1 : -1);
} }
function SdDataDetailControl_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataDetailControl_Conditional_2_ng_template_0_Template, 2, 2, "ng-template", null, 2, i0.ɵɵtemplateRefExtractor);
} }
function SdDataDetailControl_ng_template_3_Conditional_0_ng_template_1_Template(rf, ctx) { }
function SdDataDetailControl_ng_template_3_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 16);
    i0.ɵɵtemplate(1, SdDataDetailControl_ng_template_3_Conditional_0_ng_template_1_Template, 0, 0, "ng-template", 15);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r1.prevTemplateRef() ?? null);
} }
function SdDataDetailControl_ng_template_3_ng_template_4_Template(rf, ctx) { }
function SdDataDetailControl_ng_template_3_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 18);
    i0.ɵɵtext(1);
    i0.ɵɵpipe(2, "format");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate2(" \uCD5C\uC885\uC218\uC815: ", i0.ɵɵpipeBind2(2, 2, ctx_r1.parent.dataInfo().lastModifiedAt, "yyyy-MM-dd HH:mm"), " (", ctx_r1.parent.dataInfo().lastModifiedBy, ") ");
} }
function SdDataDetailControl_ng_template_3_Conditional_6_ng_template_1_Template(rf, ctx) { }
function SdDataDetailControl_ng_template_3_Conditional_6_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 16);
    i0.ɵɵtemplate(1, SdDataDetailControl_ng_template_3_Conditional_6_ng_template_1_Template, 0, 0, "ng-template", 15);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r1.nextTemplateRef() ?? null);
} }
function SdDataDetailControl_ng_template_3_Template(rf, ctx) { if (rf & 1) {
    const _r6 = i0.ɵɵgetCurrentView();
    i0.ɵɵconditionalCreate(0, SdDataDetailControl_ng_template_3_Conditional_0_Template, 2, 1, "div", 16);
    i0.ɵɵelementStart(1, "div", 16)(2, "sd-form", 17, 3);
    i0.ɵɵlistener("submit", function SdDataDetailControl_ng_template_3_Template_sd_form_submit_2_listener() { i0.ɵɵrestoreView(_r6); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onSubmit()); });
    i0.ɵɵtemplate(4, SdDataDetailControl_ng_template_3_ng_template_4_Template, 0, 0, "ng-template", 15);
    i0.ɵɵelementEnd()();
    i0.ɵɵconditionalCreate(5, SdDataDetailControl_ng_template_3_Conditional_5_Template, 3, 5, "div", 18);
    i0.ɵɵconditionalCreate(6, SdDataDetailControl_ng_template_3_Conditional_6_Template, 2, 1, "div", 16);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵconditional(ctx_r1.prevTemplateRef() != null ? 0 : -1);
    i0.ɵɵadvance(4);
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r1.contentTemplateRef());
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.parent.dataInfo && (ctx_r1.parent.dataInfo().lastModifiedAt || ctx_r1.parent.dataInfo().lastModifiedBy) ? 5 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.nextTemplateRef() != null ? 6 : -1);
} }
function SdDataDetailControl_Conditional_5_ng_template_0_Conditional_1_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r8 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 24);
    i0.ɵɵlistener("click", function SdDataDetailControl_Conditional_5_ng_template_0_Conditional_1_Conditional_1_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r8); const ctx_r1 = i0.ɵɵnextContext(4); return i0.ɵɵresetView(ctx_r1.parent.doToggleDelete(false)); });
    i0.ɵɵtext(1, " \uBCF5\uAD6C ");
    i0.ɵɵelementEnd();
} }
function SdDataDetailControl_Conditional_5_ng_template_0_Conditional_1_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    const _r9 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 25);
    i0.ɵɵlistener("click", function SdDataDetailControl_Conditional_5_ng_template_0_Conditional_1_Conditional_2_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r9); const ctx_r1 = i0.ɵɵnextContext(4); return i0.ɵɵresetView(ctx_r1.parent.doToggleDelete(true)); });
    i0.ɵɵtext(1, " \uC0AD\uC81C ");
    i0.ɵɵelementEnd();
} }
function SdDataDetailControl_Conditional_5_ng_template_0_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div");
    i0.ɵɵconditionalCreate(1, SdDataDetailControl_Conditional_5_ng_template_0_Conditional_1_Conditional_1_Template, 2, 0, "sd-button", 22)(2, SdDataDetailControl_Conditional_5_ng_template_0_Conditional_1_Conditional_2_Template, 2, 0, "sd-button", 23);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.parent.dataInfo && ctx_r1.parent.dataInfo().isDeleted ? 1 : 2);
} }
function SdDataDetailControl_Conditional_5_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    const _r7 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 19);
    i0.ɵɵconditionalCreate(1, SdDataDetailControl_Conditional_5_ng_template_0_Conditional_1_Template, 3, 1, "div");
    i0.ɵɵelementStart(2, "div", 20)(3, "sd-button", 21);
    i0.ɵɵlistener("click", function SdDataDetailControl_Conditional_5_ng_template_0_Template_sd_button_click_3_listener() { i0.ɵɵrestoreView(_r7); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onSubmitButtonClick()); });
    i0.ɵɵtext(4, "\uD655\uC778");
    i0.ɵɵelementEnd()()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵconditional((!ctx_r1.parent.isNew || !ctx_r1.parent.isNew()) && ctx_r1.parent.toggleDelete ? 1 : -1);
} }
function SdDataDetailControl_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataDetailControl_Conditional_5_ng_template_0_Template, 5, 1, "ng-template", null, 4, i0.ɵɵtemplateRefExtractor);
} }
export class SdDataDetailControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.parent = injectParent();
        this.formCtrl = viewChild("formCtrl");
        this.contentTemplateRef = contentChild.required("content", { read: TemplateRef });
        this.toolTemplateRef = contentChild("tool", { read: TemplateRef });
        this.prevTemplateRef = contentChild("prev", { read: TemplateRef });
        this.nextTemplateRef = contentChild("next", { read: TemplateRef });
    }
    async onRefreshButtonClick() {
        await this.parent.doRefresh();
    }
    onSubmitButtonClick() {
        if (this.parent.busyCount() > 0)
            return;
        this.formCtrl()?.requestSubmit();
    }
    async onSubmit() {
        await this.parent.doSubmit();
    }
    static { this.ɵfac = function SdDataDetailControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdDataDetailControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdDataDetailControl, selectors: [["sd-data-detail"]], contentQueries: function SdDataDetailControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.contentTemplateRef, _c0, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.toolTemplateRef, _c1, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.prevTemplateRef, _c2, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.nextTemplateRef, _c3, 5, TemplateRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance(4);
        } }, viewQuery: function SdDataDetailControl_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuerySignal(ctx.formCtrl, _c4, 5);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, hostBindings: function SdDataDetailControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("sdRefreshCommand", function SdDataDetailControl_sdRefreshCommand_HostBindingHandler() { return ctx.onRefreshButtonClick(); })("sdSaveCommand", function SdDataDetailControl_sdSaveCommand_HostBindingHandler() { return ctx.onSubmitButtonClick(); });
        } }, decls: 6, vars: 7, consts: [["content", ""], ["pageTopbar", ""], ["controlTool", ""], ["formCtrl", ""], ["modalBottom", ""], [3, "busy", "viewType", "initialized", "restricted"], [3, "click"], [3, "icon", "fixedWidth"], [1, "p-sm-lg", "flex-row", "flex-gap-sm"], [1, "p-sm-lg"], ["theme", "primary", 3, "click"], ["theme", "warning"], ["theme", "danger"], ["theme", "warning", 3, "click"], ["theme", "danger", 3, "click"], [3, "ngTemplateOutlet"], [1, "p-lg"], [3, "submit"], [1, "bg-theme-grey-lightest", "p-sm-default"], [1, "p-sm-default", "flex-row", "bdt", "bdt-theme-grey-lightest"], [1, "flex-grow", "tx-right"], ["theme", "primary", "inline", "", 3, "click"], ["theme", "warning", "inline", ""], ["theme", "danger", "inline", ""], ["theme", "warning", "inline", "", 3, "click"], ["theme", "danger", "inline", "", 3, "click"]], template: function SdDataDetailControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-base-container", 5);
            i0.ɵɵconditionalCreate(1, SdDataDetailControl_Conditional_1_Template, 2, 0);
            i0.ɵɵconditionalCreate(2, SdDataDetailControl_Conditional_2_Template, 2, 0);
            i0.ɵɵtemplate(3, SdDataDetailControl_ng_template_3_Template, 7, 4, "ng-template", null, 0, i0.ɵɵtemplateRefExtractor);
            i0.ɵɵconditionalCreate(5, SdDataDetailControl_Conditional_5_Template, 2, 0);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("busy", ctx.parent.busyCount() > 0)("viewType", ctx.parent.currViewType())("initialized", ctx.parent.initialized())("restricted", ctx.parent.restricted == null ? null : ctx.parent.restricted());
            i0.ɵɵadvance();
            i0.ɵɵconditional(!(ctx.parent.readonly == null ? null : ctx.parent.readonly()) ? 1 : -1);
            i0.ɵɵadvance();
            i0.ɵɵconditional(!(ctx.parent.readonly == null ? null : ctx.parent.readonly()) || ctx.toolTemplateRef() != null ? 2 : -1);
            i0.ɵɵadvance(3);
            i0.ɵɵconditional(!(ctx.parent.readonly == null ? null : ctx.parent.readonly()) ? 5 : -1);
        } }, dependencies: [SdBaseContainerControl,
            SdFormControl,
            SdButtonControl,
            NgTemplateOutlet,
            FormatPipe,
            FaIconComponent,
            SdTopbarMenuControl,
            SdTopbarMenuItemControl], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdDataDetailControl, [{
        type: Component,
        args: [{
                selector: "sd-data-detail",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [
                    SdBaseContainerControl,
                    SdFormControl,
                    SdButtonControl,
                    NgTemplateOutlet,
                    FormatPipe,
                    FaIconComponent,
                    SdTopbarMenuControl,
                    SdTopbarMenuItemControl,
                ],
                template: `
    <sd-base-container
      [busy]="parent.busyCount() > 0"
      [viewType]="parent.currViewType()"
      [initialized]="parent.initialized()"
      [restricted]="parent.restricted?.()"
    >
      @if (!parent.readonly?.()) {
        <ng-template #pageTopbar>
          <sd-topbar-menu>
            <sd-topbar-menu-item (click)="onSubmitButtonClick()">
              <fa-icon [icon]="icons.save" [fixedWidth]="true" />
              저장
              <small>(CTRL+S)</small>
            </sd-topbar-menu-item>
          </sd-topbar-menu>
        </ng-template>
      }

      @if (!parent.readonly?.() || toolTemplateRef() != null) {
        <ng-template #controlTool>
          @if (!parent.readonly?.()) {
            <div class="p-sm-lg flex-row flex-gap-sm">
              <sd-button theme="primary" (click)="onSubmitButtonClick()">
                <fa-icon [icon]="icons.save" [fixedWidth]="true" />
                저장
                <small>(CTRL+S)</small>
              </sd-button>
              @if ((!parent.isNew || !parent.isNew()) && parent.toggleDelete) {
                @if (parent.dataInfo && parent.dataInfo().isDeleted) {
                  <sd-button theme="warning" (click)="parent.doToggleDelete(false)">복구</sd-button>
                } @else {
                  <sd-button theme="danger" (click)="parent.doToggleDelete(true)">삭제</sd-button>
                }
              }
            </div>
          }
          @if (toolTemplateRef() != null) {
            <div class="p-sm-lg">
              <ng-template [ngTemplateOutlet]="toolTemplateRef() ?? null" />
            </div>
          }
        </ng-template>
      }

      <ng-template #content>
        @if (prevTemplateRef() != null) {
          <div class="p-lg">
            <ng-template [ngTemplateOutlet]="prevTemplateRef() ?? null" />
          </div>
        }
        <div class="p-lg">
          <sd-form #formCtrl (submit)="onSubmit()">
            <ng-template [ngTemplateOutlet]="contentTemplateRef()" />
          </sd-form>
        </div>
        @if (
          parent.dataInfo && (parent.dataInfo().lastModifiedAt || parent.dataInfo().lastModifiedBy)
        ) {
          <div class="bg-theme-grey-lightest p-sm-default">
            최종수정:
            {{ parent.dataInfo().lastModifiedAt! | format: "yyyy-MM-dd HH:mm" }}
            ({{ parent.dataInfo().lastModifiedBy }})
          </div>
        }
        @if (nextTemplateRef() != null) {
          <div class="p-lg">
            <ng-template [ngTemplateOutlet]="nextTemplateRef() ?? null" />
          </div>
        }
      </ng-template>

      @if (!parent.readonly?.()) {
        <ng-template #modalBottom>
          <div class="p-sm-default flex-row bdt bdt-theme-grey-lightest">
            @if ((!parent.isNew || !parent.isNew()) && parent.toggleDelete) {
              <div>
                @if (parent.dataInfo && parent.dataInfo().isDeleted) {
                  <sd-button theme="warning" inline (click)="parent.doToggleDelete(false)">
                    복구
                  </sd-button>
                } @else {
                  <sd-button theme="danger" inline (click)="parent.doToggleDelete(true)">
                    삭제
                  </sd-button>
                }
              </div>
            }

            <div class="flex-grow tx-right">
              <sd-button theme="primary" inline (click)="onSubmitButtonClick()">확인</sd-button>
            </div>
          </div>
        </ng-template>
      }
    </sd-base-container>
  `,
            }]
    }], null, { onRefreshButtonClick: [{
            type: HostListener,
            args: ["sdRefreshCommand"]
        }], onSubmitButtonClick: [{
            type: HostListener,
            args: ["sdSaveCommand"]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdDataDetailControl, { className: "SdDataDetailControl", filePath: "packages/sd-angular/src/advanced/sd-data-sheet/sd-data-detail.control.ts", lineNumber: 151 }); })();
export class AbsSdDataDetail {
    //-- implement
    #sdToast;
    #sdSharedData;
    #viewType;
    constructor() {
        //-- implement
        this.#sdToast = inject(SdToastProvider);
        this.#sdSharedData = inject(SdSharedDataProvider);
        this.#viewType = useViewTypeSignal(() => this);
        this.viewType = input();
        this.currViewType = $computed(() => this.viewType() ?? this.#viewType());
        this.busyCount = $signal(0);
        this.initialized = $signal(false);
        this.close = output();
        this.data = $signal(undefined);
        effect(() => {
            const reflected = reflectComponentType(this.constructor);
            const inputPropNames = reflected.inputs.map((item) => item.propName);
            for (const inputPropName of inputPropNames) {
                if (inputPropName === "viewType")
                    continue;
                this[inputPropName]();
            }
            queueMicrotask(async () => {
                if (this.restricted?.()) {
                    this.initialized.set(true);
                    return;
                }
                this.busyCount.update((v) => v + 1);
                await this.#sdToast.try(async () => {
                    await this.#sdSharedData.wait();
                    await this.refresh();
                });
                this.busyCount.update((v) => v - 1);
                this.initialized.set(true);
            });
        });
        setupCanDeactivate(() => this.currViewType() === "modal" || this.checkIgnoreChanges());
    }
    checkIgnoreChanges() {
        return !$obj(this.data).changed() || confirm(TXT_CHANGE_IGNORE_CONFIRM);
    }
    async doRefresh() {
        if (this.busyCount() > 0)
            return;
        if (!this.checkIgnoreChanges())
            return;
        this.busyCount.update((v) => v + 1);
        await this.#sdToast.try(async () => {
            await this.refresh();
        });
        this.busyCount.update((v) => v - 1);
    }
    async refresh() {
        this.data.set(await this.load());
        $obj(this.data).snapshot();
    }
    async doToggleDelete(del) {
        if (this.busyCount() > 0)
            return;
        if (this.readonly?.())
            return;
        this.busyCount.update((v) => v + 1);
        await this.#sdToast.try(async () => {
            const result = await this.toggleDelete?.(del);
            if (!result)
                return;
            this.#sdToast.success(`${del ? "삭제" : "복구"}되었습니다.`);
            this.close.emit(result);
        }, () => {
            return "삭제할 수 없습니다. 연동된 작업이 있는지 확인하세요.";
        });
        this.busyCount.update((v) => v - 1);
    }
    async doSubmit() {
        if (this.busyCount() > 0)
            return;
        if (this.readonly?.())
            return;
        if (!this.submit)
            return;
        if (!$obj(this.data).changed()) {
            this.#sdToast.info("변경사항이 없습니다.");
            return;
        }
        this.busyCount.update((v) => v + 1);
        await this.#sdToast.try(async () => {
            const result = await this.submit();
            // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition,@typescript-eslint/strict-boolean-expressions
            if (!result)
                return;
            this.#sdToast.success("저장되었습니다.");
            this.close.emit(result);
            await this.refresh();
        });
        this.busyCount.update((v) => v - 1);
    }
    static { this.ɵfac = function AbsSdDataDetail_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || AbsSdDataDetail)(); }; }
    static { this.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: AbsSdDataDetail, inputs: { viewType: [1, "viewType"] }, outputs: { close: "close" } }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(AbsSdDataDetail, [{
        type: Directive
    }], () => [], null); })();
//# sourceMappingURL=sd-data-detail.control.js.map