import { InputSignal, Signal, TemplateRef } from "@angular/core";
import { TSelectModeValue } from "../../controls/sd-select-control";
import { ISdModal, ISdModalInfo } from "../../providers/sd-modal.provider";
import { SdItemOfTemplateContext } from "../../directives/sd-item-of.template-directive";
import * as i0 from "@angular/core";
export declare class SdDataSelectButtonControl {
    protected readonly icons: import("../../providers/sd-angular-config.provider").ISdAngularIcon;
    parent: any;
    itemTemplateRef: Signal<TemplateRef<SdItemOfTemplateContext<any>>>;
    onModalButtonClick(event: MouseEvent): Promise<void>;
    onCancelButtonClick(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdDataSelectButtonControl, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdDataSelectButtonControl, "sd-data-select-button", never, {}, {}, ["itemTemplateRef"], never, true, never>;
}
export declare abstract class AbsSdDataSelectButton<T extends object, K, M extends keyof TSelectModeValue<K> = keyof TSelectModeValue<K>> {
    #private;
    abstract modal: Signal<TSdSelectModalInfo<ISdSelectModal>>;
    abstract load(keys: K[]): Promise<T[]> | T[];
    value: import("@angular/core").ModelSignal<TSelectModeValue<K>[M] | undefined>;
    disabled: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    required: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    inset: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    size: InputSignal<"sm" | "lg" | undefined>;
    selectMode: InputSignal<M>;
    isNoValue: Signal<boolean>;
    selectedItems: import("../../utils/bindings/$signal").SdWritableSignal<T[]>;
    constructor();
    doShowModal(): Promise<void>;
    doInitialValue(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AbsSdDataSelectButton<any, any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AbsSdDataSelectButton<any, any, any>, never, never, { "value": { "alias": "value"; "required": false; "isSignal": true; }; "disabled": { "alias": "disabled"; "required": false; "isSignal": true; }; "required": { "alias": "required"; "required": false; "isSignal": true; }; "inset": { "alias": "inset"; "required": false; "isSignal": true; }; "size": { "alias": "size"; "required": false; "isSignal": true; }; "selectMode": { "alias": "selectMode"; "required": false; "isSignal": true; }; }, { "value": "valueChange"; }, never, never, true, never>;
}
export interface ISdSelectModal extends ISdModal<ISelectModalOutputResult> {
    selectMode: InputSignal<"single" | "multi" | undefined>;
    selectedItemKeys: InputSignal<any[]>;
}
export type TSdSelectModalInfo<T extends ISdSelectModal> = ISdModalInfo<T, "selectMode" | "selectedItemKeys">;
export interface ISelectModalOutputResult {
    selectedItemKeys: any[];
}
