import { ChangeDetectionStrategy, Component, contentChild, Directive, inject, input, model, TemplateRef, ViewEncapsulation, } from "@angular/core";
import { FaIconComponent } from "@fortawesome/angular-fontawesome";
import { SdAdditionalButtonControl } from "../../controls/sd-additional-button.control";
import { SdButtonControl } from "../../controls/sd-button.control";
import { SdAnchorControl } from "../../controls/sd-anchor.control";
import { SdAngularConfigProvider } from "../../providers/sd-angular-config.provider";
import { SdModalProvider } from "../../providers/sd-modal.provider";
import { transformBoolean } from "../../utils/type-tramsforms";
import { $computed } from "../../utils/bindings/$computed";
import { setupInvalid } from "../../utils/setups/setup-invalid";
import { $effect } from "../../utils/bindings/$effect";
import { SdItemOfTemplateDirective, } from "../../directives/sd-item-of.template-directive";
import { NgTemplateOutlet } from "@angular/common";
import { $signal } from "../../utils/bindings/$signal";
import { injectParent } from "../../utils/injections/inject-parent";
import * as i0 from "@angular/core";
const _c0 = (a0, a1, a2) => ({ $implicit: a0, item: a1, index: a2, depth: 0 });
function SdDataSelectButtonControl_For_2_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 3);
    i0.ɵɵtext(1, ",\u00A0");
    i0.ɵɵelementEnd();
} }
function SdDataSelectButtonControl_For_2_ng_template_2_Template(rf, ctx) { }
function SdDataSelectButtonControl_For_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵconditionalCreate(0, SdDataSelectButtonControl_For_2_Conditional_0_Template, 2, 0, "div", 3);
    i0.ɵɵelementStart(1, "div", 3);
    i0.ɵɵtemplate(2, SdDataSelectButtonControl_For_2_ng_template_2_Template, 0, 0, "ng-template", 4);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const item_r1 = ctx.$implicit;
    const ɵ$index_3_r2 = ctx.$index;
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵconditional(ɵ$index_3_r2 !== 0 ? 0 : -1);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r2.itemTemplateRef())("ngTemplateOutletContext", i0.ɵɵpureFunction3(3, _c0, item_r1, item_r1, ɵ$index_3_r2));
} }
function SdDataSelectButtonControl_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-anchor", 5);
    i0.ɵɵlistener("click", function SdDataSelectButtonControl_Conditional_3_Template_sd_anchor_click_0_listener() { i0.ɵɵrestoreView(_r4); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onCancelButtonClick()); });
    i0.ɵɵelement(1, "fa-icon", 6);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r2.icons.xmark);
} }
function SdDataSelectButtonControl_Conditional_4_Template(rf, ctx) { if (rf & 1) {
    const _r5 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 7);
    i0.ɵɵlistener("click", function SdDataSelectButtonControl_Conditional_4_Template_sd_button_click_0_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onModalButtonClick($event)); });
    i0.ɵɵelement(1, "fa-icon", 6);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r2.icons.search);
} }
export class SdDataSelectButtonControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.parent = injectParent();
        this.itemTemplateRef = contentChild.required(SdItemOfTemplateDirective, {
            read: TemplateRef,
        });
    }
    async onModalButtonClick(event) {
        event.preventDefault();
        event.stopPropagation();
        await this.parent.doShowModal();
    }
    async onCancelButtonClick() {
        await this.parent.doInitialValue();
    }
    static { this.ɵfac = function SdDataSelectButtonControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdDataSelectButtonControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdDataSelectButtonControl, selectors: [["sd-data-select-button"]], contentQueries: function SdDataSelectButtonControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.itemTemplateRef, SdItemOfTemplateDirective, 5, TemplateRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, decls: 5, vars: 4, consts: [[3, "inset", "size"], ["theme", "danger"], ["inset", ""], [2, "display", "inline-block"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"], ["theme", "danger", 3, "click"], [3, "icon"], ["inset", "", 3, "click"]], template: function SdDataSelectButtonControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-additional-button", 0);
            i0.ɵɵrepeaterCreate(1, SdDataSelectButtonControl_For_2_Template, 3, 7, null, null, i0.ɵɵrepeaterTrackByIdentity);
            i0.ɵɵconditionalCreate(3, SdDataSelectButtonControl_Conditional_3_Template, 2, 1, "sd-anchor", 1);
            i0.ɵɵconditionalCreate(4, SdDataSelectButtonControl_Conditional_4_Template, 2, 1, "sd-button", 2);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("inset", ctx.parent.inset())("size", ctx.parent.size());
            i0.ɵɵadvance();
            i0.ɵɵrepeater(ctx.parent.selectedItems());
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(!ctx.parent.disabled() && !ctx.parent.isNoValue() ? 3 : -1);
            i0.ɵɵadvance();
            i0.ɵɵconditional(!ctx.parent.disabled() ? 4 : -1);
        } }, dependencies: [SdAdditionalButtonControl,
            FaIconComponent,
            SdButtonControl,
            SdAnchorControl,
            NgTemplateOutlet], styles: ["sd-select-modal-button{display:block;width:100%;min-width:10em}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdDataSelectButtonControl, [{
        type: Component,
        args: [{ selector: "sd-data-select-button", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [
                    SdAdditionalButtonControl,
                    FaIconComponent,
                    SdButtonControl,
                    SdAnchorControl,
                    NgTemplateOutlet,
                ], template: `
    <sd-additional-button [inset]="parent.inset()" [size]="parent.size()">
      @for (item of parent.selectedItems(); track item; let index = $index) {
        @if (index !== 0) {
          <div style="display: inline-block">,&nbsp;</div>
        }
        <div style="display: inline-block">
          <ng-template
            [ngTemplateOutlet]="itemTemplateRef()"
            [ngTemplateOutletContext]="{
              $implicit: item,
              item: item,
              index: index,
              depth: 0,
            }"
          ></ng-template>
        </div>
      }

      @if (!parent.disabled() && !parent.isNoValue()) {
        <sd-anchor (click)="onCancelButtonClick()" theme="danger">
          <fa-icon [icon]="icons.xmark" />
        </sd-anchor>
      }

      @if (!parent.disabled()) {
        <sd-button (click)="onModalButtonClick($event)" inset>
          <fa-icon [icon]="icons.search" />
        </sd-button>
      }
    </sd-additional-button>
  `, styles: ["sd-select-modal-button{display:block;width:100%;min-width:10em}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdDataSelectButtonControl, { className: "SdDataSelectButtonControl", filePath: "packages/sd-angular/src/advanced/sd-data-sheet/sd-data-select-button.control.ts", lineNumber: 87 }); })();
export class AbsSdDataSelectButton {
    //-- implement
    #sdModal;
    constructor() {
        //-- implement
        this.#sdModal = inject(SdModalProvider);
        this.value = model();
        this.disabled = input(false, { transform: transformBoolean });
        this.required = input(false, { transform: transformBoolean });
        this.inset = input(false, { transform: transformBoolean });
        this.size = input();
        this.selectMode = input("single");
        this.isNoValue = $computed(() => {
            return (this.value() == null ||
                (this.selectMode() === "multi" && this.value().length === 0));
        });
        this.selectedItems = $signal([]);
        setupInvalid(() => (this.required() && this.value() == null ? "값을 입력하세요." : ""));
        $effect([this.value], async () => {
            const value = this.value();
            if (this.selectMode() === "multi" &&
                value instanceof Array &&
                value.filterExists().length > 0) {
                this.selectedItems.set(await this.load(value.filterExists()));
            }
            else if (this.selectMode() === "single" && !(value instanceof Array) && value != null) {
                this.selectedItems.set(await this.load([value]));
            }
            else {
                this.selectedItems.set([]);
            }
        });
    }
    async doShowModal() {
        const modal = this.modal();
        const result = await this.#sdModal.showAsync({
            ...modal,
            inputs: {
                selectMode: this.selectMode(),
                selectedItemKeys: (this.selectMode() === "multi"
                    ? this.value()
                    : [this.value()]).filterExists(),
                ...modal.inputs,
            },
        });
        if (result) {
            const newValue = this.selectMode() === "multi" ? result.selectedItemKeys : result.selectedItemKeys[0];
            this.value.set(newValue);
        }
    }
    doInitialValue() {
        this.value.set((this.selectMode() === "multi" ? [] : undefined));
    }
    static { this.ɵfac = function AbsSdDataSelectButton_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || AbsSdDataSelectButton)(); }; }
    static { this.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: AbsSdDataSelectButton, inputs: { value: [1, "value"], disabled: [1, "disabled"], required: [1, "required"], inset: [1, "inset"], size: [1, "size"], selectMode: [1, "selectMode"] }, outputs: { value: "valueChange" } }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(AbsSdDataSelectButton, [{
        type: Directive
    }], () => [], null); })();
//# sourceMappingURL=sd-data-select-button.control.js.map