import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChildren, Directive, effect, HostListener, inject, input, model, output, reflectComponentType, ViewEncapsulation, } from "@angular/core";
import { ObjectUtils } from "@simplysm/sd-core-common";
import { SdAnchorControl } from "../../controls/sd-anchor.control";
import { SdButtonControl } from "../../controls/sd-button.control";
import { SdDockContainerControl } from "../../controls/sd-dock-container.control";
import { SdDockControl } from "../../controls/sd-dock.control";
import { SdFormBoxItemControl } from "../../controls/sd-form-box-item.control";
import { SdFormBoxControl } from "../../controls/sd-form-box.control";
import { SdFormControl } from "../../controls/sd-form.control";
import { SdPaneControl } from "../../controls/sd-pane.control";
import { SdSheetColumnCellTemplateDirective } from "../../controls/sd-sheet/directives/sd-sheet-column-cell.template-directive";
import { SdSheetColumnDirective } from "../../controls/sd-sheet/directives/sd-sheet-column.directive";
import { SdSheetControl } from "../../controls/sd-sheet/sd-sheet.control";
import { SdFileDialogProvider } from "../../providers/sd-file-dialog.provider";
import { SdToastProvider } from "../../providers/sd-toast.provider";
import { $computed } from "../../utils/bindings/$computed";
import { $signal } from "../../utils/bindings/$signal";
import { setupCumulateSelectedKeys } from "../../utils/setups/setup-cumulate-selected-keys";
import { useViewTypeSignal } from "../../utils/signals/use-view-type.signal";
import { SdBaseContainerControl } from "../sd-base-container.control";
import { SdSharedDataProvider } from "../shared-data/sd-shared-data.provider";
import { SdDataSheetColumnDirective } from "./sd-data-sheet-column.directive";
import { SdDataSheetFilterDirective } from "./sd-data-sheet-filter.directive";
import { SdDataSheetToolDirective } from "./sd-data-sheet-tool.directive";
import { setupCloserWhenSingleSelectionChange } from "../../utils/setups/setup-closer-when-single-selection-change";
import { FaIconComponent } from "@fortawesome/angular-fontawesome";
import { SdAngularConfigProvider } from "../../providers/sd-angular-config.provider";
import { injectParent } from "../../utils/injections/inject-parent";
import * as i0 from "@angular/core";
const _c0 = (a0, a1, a2, a3, a4) => ({ $implicit: a0, item: a1, index: a2, depth: a3, edit: a4 });
const _forTrack0 = ($index, $item) => $item.key();
function SdDataSheetControl_ng_template_1_For_9_Conditional_1_ng_template_0_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_1_For_9_Conditional_1_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_1_For_9_Conditional_1_ng_template_0_ng_template_0_Template, 0, 0, "ng-template", 15);
} if (rf & 2) {
    const filterControl_r3 = i0.ɵɵnextContext(2).$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", filterControl_r3.labelTemplateRef());
} }
function SdDataSheetControl_ng_template_1_For_9_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_1_For_9_Conditional_1_ng_template_0_Template, 1, 1, "ng-template", null, 1, i0.ɵɵtemplateRefExtractor);
} }
function SdDataSheetControl_ng_template_1_For_9_ng_template_2_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_1_For_9_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-form-box-item", 12);
    i0.ɵɵconditionalCreate(1, SdDataSheetControl_ng_template_1_For_9_Conditional_1_Template, 2, 0);
    i0.ɵɵtemplate(2, SdDataSheetControl_ng_template_1_For_9_ng_template_2_Template, 0, 0, "ng-template", 15);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const filterControl_r3 = ctx.$implicit;
    i0.ɵɵproperty("label", filterControl_r3.label())("labelTooltip", filterControl_r3.labelTooltip());
    i0.ɵɵadvance();
    i0.ɵɵconditional(filterControl_r3.labelTemplateRef() ? 1 : -1);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", filterControl_r3.contentTemplateRef());
} }
function SdDataSheetControl_ng_template_1_Conditional_12_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 20);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_1_Conditional_12_Conditional_0_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r4); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.onCreateItemButtonClick()); });
    i0.ɵɵelement(1, "fa-icon", 11);
    i0.ɵɵtext(2);
    i0.ɵɵelementStart(3, "small");
    i0.ɵɵtext(4, "(CTRL+INSERT)");
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.add)("fixedWidth", true);
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate1(" ", ctx_r1.insertText(), " ");
} }
function SdDataSheetControl_ng_template_1_Conditional_12_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵconditionalCreate(0, SdDataSheetControl_ng_template_1_Conditional_12_Conditional_0_Template, 5, 3, "sd-button", 19);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵconditional(!(ctx_r1.parent.readonly == null ? null : ctx_r1.parent.readonly()) ? 0 : -1);
} }
function SdDataSheetControl_ng_template_1_For_14_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_1_For_14_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_1_For_14_ng_template_0_Template, 0, 0, "ng-template", 15);
} if (rf & 2) {
    const toolControl_r5 = ctx.$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", toolControl_r5.contentTemplateRef());
} }
function SdDataSheetControl_ng_template_1_Conditional_15_Conditional_0_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r7 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 23);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_1_Conditional_15_Conditional_0_Conditional_3_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r7); const ctx_r1 = i0.ɵɵnextContext(4); return i0.ɵɵresetView(ctx_r1.onToggleDeleteItemsButtonClick(false)); });
    i0.ɵɵelement(1, "fa-icon", 11);
    i0.ɵɵtext(2, " \uC120\uD0DD \uBCF5\uAD6C ");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(4);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.redo)("fixedWidth", true);
} }
function SdDataSheetControl_ng_template_1_Conditional_15_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r6 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 21);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_1_Conditional_15_Conditional_0_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r6); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.onToggleDeleteItemsButtonClick(true)); });
    i0.ɵɵelement(1, "fa-icon", 11);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵconditionalCreate(3, SdDataSheetControl_ng_template_1_Conditional_15_Conditional_0_Conditional_3_Template, 3, 2, "sd-button", 22);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵproperty("disabled", !ctx_r1.parent.isSelectedItemsHasNotDeleted());
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.eraser)("fixedWidth", true);
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate1(" \uC120\uD0DD ", ctx_r1.deleteText(), " ");
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.parent.isSelectedItemsHasDeleted() ? 3 : -1);
} }
function SdDataSheetControl_ng_template_1_Conditional_15_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r8 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 24);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_1_Conditional_15_Conditional_1_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r8); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.onUploadExcelButtonClick()); });
    i0.ɵɵelement(1, "fa-icon", 11);
    i0.ɵɵtext(2, " \uC5D1\uC140 \uC5C5\uB85C\uB4DC ");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.upload)("fixedWidth", true);
} }
function SdDataSheetControl_ng_template_1_Conditional_15_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵconditionalCreate(0, SdDataSheetControl_ng_template_1_Conditional_15_Conditional_0_Template, 4, 5);
    i0.ɵɵconditionalCreate(1, SdDataSheetControl_ng_template_1_Conditional_15_Conditional_1_Template, 3, 2, "sd-button", 16);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵconditional(ctx_r1.parent.toggleDeleteItems ? 0 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.parent.uploadExcel ? 1 : -1);
} }
function SdDataSheetControl_ng_template_1_Conditional_16_Template(rf, ctx) { if (rf & 1) {
    const _r9 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 24);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_1_Conditional_16_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r9); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onDownloadExcelButtonClick()); });
    i0.ɵɵelement(1, "fa-icon", 11);
    i0.ɵɵtext(2, " \uC5D1\uC140 \uB2E4\uC6B4\uB85C\uB4DC ");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.fileExcel)("fixedWidth", true);
} }
function SdDataSheetControl_ng_template_1_For_18_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_1_For_18_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_1_For_18_ng_template_0_Template, 0, 0, "ng-template", 15);
} if (rf & 2) {
    const toolControl_r10 = ctx.$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", toolControl_r10.contentTemplateRef());
} }
function SdDataSheetControl_ng_template_1_For_22_Conditional_1_ng_template_0_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_1_For_22_Conditional_1_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_1_For_22_Conditional_1_ng_template_0_ng_template_0_Template, 0, 0, "ng-template", 15);
} if (rf & 2) {
    const columnControl_r11 = i0.ɵɵnextContext(2).$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", columnControl_r11.headerTemplateRef());
} }
function SdDataSheetControl_ng_template_1_For_22_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_1_For_22_Conditional_1_ng_template_0_Template, 1, 1, "ng-template", null, 2, i0.ɵɵtemplateRefExtractor);
} }
function SdDataSheetControl_ng_template_1_For_22_Conditional_2_ng_template_0_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_1_For_22_Conditional_2_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_1_For_22_Conditional_2_ng_template_0_ng_template_0_Template, 0, 0, "ng-template", 15);
} if (rf & 2) {
    const columnControl_r11 = i0.ɵɵnextContext(2).$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", columnControl_r11.summaryTemplateRef());
} }
function SdDataSheetControl_ng_template_1_For_22_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_1_For_22_Conditional_2_ng_template_0_Template, 1, 1, "ng-template", null, 3, i0.ɵɵtemplateRefExtractor);
} }
function SdDataSheetControl_ng_template_1_For_22_ng_template_3_Conditional_0_ng_template_4_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_1_For_22_ng_template_3_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r12 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-anchor", 28);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_1_For_22_ng_template_3_Conditional_0_Template_sd_anchor_click_0_listener($event) { i0.ɵɵrestoreView(_r12); const ctx_r12 = i0.ɵɵnextContext(); const item_r14 = ctx_r12.$implicit; const index_r15 = ctx_r12.index; const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.onEditItemButtonClick(item_r14, index_r15, $event)); });
    i0.ɵɵelementStart(1, "div", 29);
    i0.ɵɵelement(2, "fa-icon", 11);
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(3, "div", 30);
    i0.ɵɵtemplate(4, SdDataSheetControl_ng_template_1_For_22_ng_template_3_Conditional_0_ng_template_4_Template, 0, 0, "ng-template", 27);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r12 = i0.ɵɵnextContext();
    const item_r14 = ctx_r12.$implicit;
    const index_r15 = ctx_r12.index;
    const depth_r16 = ctx_r12.depth;
    const edit_r17 = ctx_r12.edit;
    const columnControl_r11 = i0.ɵɵnextContext().$implicit;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r1.icons.edit)("fixedWidth", true);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngTemplateOutlet", columnControl_r11.cellTemplateRef())("ngTemplateOutletContext", i0.ɵɵpureFunction5(4, _c0, item_r14, item_r14, index_r15, depth_r16, edit_r17));
} }
function SdDataSheetControl_ng_template_1_For_22_ng_template_3_Conditional_1_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_1_For_22_ng_template_3_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_1_For_22_ng_template_3_Conditional_1_ng_template_0_Template, 0, 0, "ng-template", 27);
} if (rf & 2) {
    const ctx_r12 = i0.ɵɵnextContext();
    const item_r14 = ctx_r12.$implicit;
    const index_r15 = ctx_r12.index;
    const depth_r16 = ctx_r12.depth;
    const edit_r17 = ctx_r12.edit;
    const columnControl_r11 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", columnControl_r11.cellTemplateRef())("ngTemplateOutletContext", i0.ɵɵpureFunction5(2, _c0, item_r14, item_r14, index_r15, depth_r16, edit_r17));
} }
function SdDataSheetControl_ng_template_1_For_22_ng_template_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵconditionalCreate(0, SdDataSheetControl_ng_template_1_For_22_ng_template_3_Conditional_0_Template, 5, 10, "sd-anchor", 26)(1, SdDataSheetControl_ng_template_1_For_22_ng_template_3_Conditional_1_Template, 1, 8, null, 27);
} if (rf & 2) {
    const columnControl_r11 = i0.ɵɵnextContext().$implicit;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵconditional(ctx_r1.parent.editItem && columnControl_r11.edit() && !(ctx_r1.parent.readonly == null ? null : ctx_r1.parent.readonly()) ? 0 : 1);
} }
function SdDataSheetControl_ng_template_1_For_22_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-sheet-column", 18);
    i0.ɵɵconditionalCreate(1, SdDataSheetControl_ng_template_1_For_22_Conditional_1_Template, 2, 0);
    i0.ɵɵconditionalCreate(2, SdDataSheetControl_ng_template_1_For_22_Conditional_2_Template, 2, 0);
    i0.ɵɵtemplate(3, SdDataSheetControl_ng_template_1_For_22_ng_template_3_Template, 2, 1, "ng-template", 25);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const columnControl_r11 = ctx.$implicit;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵproperty("key", columnControl_r11.key())("fixed", columnControl_r11.fixed())("header", columnControl_r11.header())("headerStyle", columnControl_r11.headerStyle())("tooltip", columnControl_r11.tooltip())("width", columnControl_r11.width())("disableSorting", columnControl_r11.disableSorting())("disableResizing", columnControl_r11.disableResizing())("hidden", columnControl_r11.hidden())("collapse", columnControl_r11.collapse());
    i0.ɵɵadvance();
    i0.ɵɵconditional(columnControl_r11.headerTemplateRef() ? 1 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(columnControl_r11.summaryTemplateRef() ? 2 : -1);
    i0.ɵɵadvance();
    i0.ɵɵproperty("cell", ctx_r1.parent.items());
} }
function SdDataSheetControl_ng_template_1_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-dock-container", 6)(1, "sd-dock", 7)(2, "sd-form", 8);
    i0.ɵɵlistener("submit", function SdDataSheetControl_ng_template_1_Template_sd_form_submit_2_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onFilterSubmit()); });
    i0.ɵɵelementStart(3, "sd-form-box", 9)(4, "sd-form-box-item")(5, "sd-button", 10);
    i0.ɵɵelement(6, "fa-icon", 11);
    i0.ɵɵtext(7, " \uC870\uD68C ");
    i0.ɵɵelementEnd()();
    i0.ɵɵrepeaterCreate(8, SdDataSheetControl_ng_template_1_For_9_Template, 3, 4, "sd-form-box-item", 12, i0.ɵɵrepeaterTrackByIdentity);
    i0.ɵɵelementEnd()()();
    i0.ɵɵelementStart(10, "sd-dock", 13)(11, "div", 14);
    i0.ɵɵconditionalCreate(12, SdDataSheetControl_ng_template_1_Conditional_12_Template, 1, 1);
    i0.ɵɵrepeaterCreate(13, SdDataSheetControl_ng_template_1_For_14_Template, 1, 1, null, 15, i0.ɵɵrepeaterTrackByIdentity);
    i0.ɵɵconditionalCreate(15, SdDataSheetControl_ng_template_1_Conditional_15_Template, 2, 2);
    i0.ɵɵconditionalCreate(16, SdDataSheetControl_ng_template_1_Conditional_16_Template, 3, 2, "sd-button", 16);
    i0.ɵɵrepeaterCreate(17, SdDataSheetControl_ng_template_1_For_18_Template, 1, 1, null, 15, i0.ɵɵrepeaterTrackByIdentity);
    i0.ɵɵelementEnd()();
    i0.ɵɵelementStart(19, "sd-pane")(20, "sd-sheet", 17);
    i0.ɵɵtwoWayListener("currentPageChange", function SdDataSheetControl_ng_template_1_Template_sd_sheet_currentPageChange_20_listener($event) { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); i0.ɵɵtwoWayBindingSet(ctx_r1.parent.page, $event) || (ctx_r1.parent.page = $event); return i0.ɵɵresetView($event); })("sortsChange", function SdDataSheetControl_ng_template_1_Template_sd_sheet_sortsChange_20_listener($event) { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); i0.ɵɵtwoWayBindingSet(ctx_r1.parent.sortingDefs, $event) || (ctx_r1.parent.sortingDefs = $event); return i0.ɵɵresetView($event); })("selectedItemsChange", function SdDataSheetControl_ng_template_1_Template_sd_sheet_selectedItemsChange_20_listener($event) { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); i0.ɵɵtwoWayBindingSet(ctx_r1.parent.selectedItems, $event) || (ctx_r1.parent.selectedItems = $event); return i0.ɵɵresetView($event); });
    i0.ɵɵrepeaterCreate(21, SdDataSheetControl_ng_template_1_For_22_Template, 4, 13, "sd-sheet-column", 18, _forTrack0);
    i0.ɵɵelementEnd()()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance(6);
    i0.ɵɵproperty("icon", ctx_r1.icons.search)("fixedWidth", true);
    i0.ɵɵadvance(2);
    i0.ɵɵrepeater(ctx_r1.filterControls());
    i0.ɵɵadvance(4);
    i0.ɵɵconditional(ctx_r1.parent.editItem ? 12 : -1);
    i0.ɵɵadvance();
    i0.ɵɵrepeater(ctx_r1.beforeToolControls());
    i0.ɵɵadvance(2);
    i0.ɵɵconditional(!ctx_r1.parent.selectMode() ? 15 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.parent.downloadExcel ? 16 : -1);
    i0.ɵɵadvance();
    i0.ɵɵrepeater(ctx_r1.afterToolControls());
    i0.ɵɵadvance(3);
    i0.ɵɵproperty("key", ctx_r1.parent.key + "-sheet")("items", ctx_r1.parent.items());
    i0.ɵɵtwoWayProperty("currentPage", ctx_r1.parent.page);
    i0.ɵɵproperty("totalPageCount", ctx_r1.parent.pageLength());
    i0.ɵɵtwoWayProperty("sorts", ctx_r1.parent.sortingDefs);
    i0.ɵɵproperty("selectMode", (ctx_r1.parent.selectMode() ?? ctx_r1.parent.toggleDeleteItems) ? "multi" : undefined)("autoSelect", ctx_r1.parent.selectMode() === "single" ? "click" : undefined);
    i0.ɵɵtwoWayProperty("selectedItems", ctx_r1.parent.selectedItems);
    i0.ɵɵproperty("trackByFn", ctx_r1.parent.trackByFn)("getItemCellStyleFn", ctx_r1.parent.getItemCellStyleFn);
    i0.ɵɵadvance();
    i0.ɵɵrepeater(ctx_r1.columnControls());
} }
function SdDataSheetControl_Conditional_3_ng_template_0_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r19 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 34);
    i0.ɵɵlistener("click", function SdDataSheetControl_Conditional_3_ng_template_0_Conditional_3_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r19); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.onConfirmButtonClick()); });
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate1(" \uD655\uC778(", ctx_r1.parent.selectedItemKeys().length, ") ");
} }
function SdDataSheetControl_Conditional_3_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    const _r18 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 31)(1, "sd-button", 32);
    i0.ɵɵlistener("click", function SdDataSheetControl_Conditional_3_ng_template_0_Template_sd_button_click_1_listener() { i0.ɵɵrestoreView(_r18); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onCancelButtonClick()); });
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵconditionalCreate(3, SdDataSheetControl_Conditional_3_ng_template_0_Conditional_3_Template, 2, 1, "sd-button", 33);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate1(" ", ctx_r1.parent.selectMode() === "multi" ? "\uBAA8\uB450" : "\uC120\uD0DD", " \uD574\uC81C ");
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.parent.selectMode() === "multi" ? 3 : -1);
} }
function SdDataSheetControl_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_Conditional_3_ng_template_0_Template, 4, 2, "ng-template", null, 4, i0.ɵɵtemplateRefExtractor);
} }
export class SdDataSheetControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.parent = injectParent();
        this.insertText = input("등록");
        this.deleteText = input("삭제");
        this.filterControls = contentChildren(SdDataSheetFilterDirective);
        this.toolControls = contentChildren(SdDataSheetToolDirective);
        this.columnControls = contentChildren((SdDataSheetColumnDirective));
        this.beforeToolControls = $computed(() => this.toolControls().filter((item) => item.prepend()));
        this.afterToolControls = $computed(() => this.toolControls().filter((item) => !item.prepend()));
    }
    onFilterSubmit() {
        this.parent.doFilterSubmit();
    }
    onRefreshCommand() {
        this.parent.doRefresh();
    }
    //-- edit
    async onCreateItemButtonClick() {
        await this.parent.doEditItem();
    }
    async onEditItemButtonClick(item, index, event) {
        event.preventDefault();
        event.stopPropagation();
        await this.parent.doEditItem(item);
    }
    async onToggleDeleteItemsButtonClick(del) {
        await this.parent.doToggleDeleteItems(del);
    }
    //-- excel
    async onDownloadExcelButtonClick() {
        await this.parent.doDownloadExcel();
    }
    async onUploadExcelButtonClick() {
        await this.parent.doUploadExcel();
    }
    //-- modal
    async onConfirmButtonClick() {
        await this.parent.doModalConfirm();
    }
    async onCancelButtonClick() {
        await this.parent.doModalCancel();
    }
    static { this.ɵfac = function SdDataSheetControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdDataSheetControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdDataSheetControl, selectors: [["sd-data-sheet"]], contentQueries: function SdDataSheetControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.filterControls, SdDataSheetFilterDirective, 4);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.toolControls, SdDataSheetToolDirective, 4);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.columnControls, (SdDataSheetColumnDirective), 4);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance(3);
        } }, hostBindings: function SdDataSheetControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("sdRefreshCommand", function SdDataSheetControl_sdRefreshCommand_HostBindingHandler() { return ctx.onRefreshCommand(); });
        } }, inputs: { insertText: [1, "insertText"], deleteText: [1, "deleteText"] }, decls: 4, vars: 5, consts: [["content", ""], ["label", ""], ["header", ""], ["summary", ""], ["modalBottom", ""], [3, "busy", "viewType", "initialized", "restricted"], [1, "p-lg"], [1, "pb-lg"], [3, "submit"], ["layout", "inline"], ["type", "submit", "theme", "info"], [3, "icon", "fixedWidth"], [3, "label", "labelTooltip"], [1, "pb-xs"], [1, "flex-row", "flex-gap-sm"], [3, "ngTemplateOutlet"], ["size", "sm", "theme", "link-success"], [3, "currentPageChange", "sortsChange", "selectedItemsChange", "key", "items", "currentPage", "totalPageCount", "sorts", "selectMode", "autoSelect", "selectedItems", "trackByFn", "getItemCellStyleFn"], [3, "key", "fixed", "header", "headerStyle", "tooltip", "width", "disableSorting", "disableResizing", "hidden", "collapse"], ["size", "sm", "theme", "primary"], ["size", "sm", "theme", "primary", 3, "click"], ["size", "sm", "theme", "link-danger", 3, "click", "disabled"], ["size", "sm", "theme", "link-warning"], ["size", "sm", "theme", "link-warning", 3, "click"], ["size", "sm", "theme", "link-success", 3, "click"], [3, "cell"], [1, "flex-row"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"], [1, "flex-row", 3, "click"], [1, "p-xs-sm", "pr-0"], [1, "flex-grow"], [1, "p-sm-default", "bdt", "bdt-trans-light", "flex-row", "flex-gap-sm", 2, "justify-content", "right"], ["theme", "danger", "inline", "", 3, "click"], ["theme", "primary", "inline", ""], ["theme", "primary", "inline", "", 3, "click"]], template: function SdDataSheetControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-base-container", 5);
            i0.ɵɵtemplate(1, SdDataSheetControl_ng_template_1_Template, 23, 15, "ng-template", null, 0, i0.ɵɵtemplateRefExtractor);
            i0.ɵɵconditionalCreate(3, SdDataSheetControl_Conditional_3_Template, 2, 0);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("busy", ctx.parent.busyCount() > 0)("viewType", ctx.parent.currViewType())("initialized", ctx.parent.initialized())("restricted", ctx.parent.restricted == null ? null : ctx.parent.restricted());
            i0.ɵɵadvance(3);
            i0.ɵɵconditional(ctx.parent.selectMode() ? 3 : -1);
        } }, dependencies: [SdDockContainerControl,
            SdDockControl,
            SdFormControl,
            SdFormBoxControl,
            SdFormBoxItemControl,
            SdButtonControl,
            SdPaneControl,
            SdSheetControl,
            SdSheetColumnDirective,
            SdSheetColumnCellTemplateDirective,
            SdAnchorControl,
            NgTemplateOutlet,
            SdBaseContainerControl,
            FaIconComponent], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdDataSheetControl, [{
        type: Component,
        args: [{
                selector: "sd-data-sheet",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [
                    SdDockContainerControl,
                    SdDockControl,
                    SdFormControl,
                    SdFormBoxControl,
                    SdFormBoxItemControl,
                    SdButtonControl,
                    SdPaneControl,
                    SdSheetControl,
                    SdSheetColumnDirective,
                    SdSheetColumnCellTemplateDirective,
                    SdAnchorControl,
                    NgTemplateOutlet,
                    SdBaseContainerControl,
                    FaIconComponent,
                ],
                template: `
    <sd-base-container
      [busy]="parent.busyCount() > 0"
      [viewType]="parent.currViewType()"
      [initialized]="parent.initialized()"
      [restricted]="parent.restricted?.()"
    >
      <ng-template #content>
        <sd-dock-container class="p-lg">
          <sd-dock class="pb-lg">
            <sd-form (submit)="onFilterSubmit()">
              <sd-form-box layout="inline">
                <sd-form-box-item>
                  <sd-button type="submit" theme="info">
                    <fa-icon [icon]="icons.search" [fixedWidth]="true" />
                    조회
                  </sd-button>
                </sd-form-box-item>
                @for (filterControl of filterControls(); track filterControl) {
                  <sd-form-box-item
                    [label]="filterControl.label()"
                    [labelTooltip]="filterControl.labelTooltip()"
                  >
                    @if (filterControl.labelTemplateRef()) {
                      <ng-template #label>
                        <ng-template [ngTemplateOutlet]="filterControl.labelTemplateRef()!" />
                      </ng-template>
                    }
                    <ng-template [ngTemplateOutlet]="filterControl.contentTemplateRef()" />
                  </sd-form-box-item>
                }
              </sd-form-box>
            </sd-form>
          </sd-dock>

          <sd-dock class="pb-xs">
            <div class="flex-row flex-gap-sm">
              @if (parent.editItem) {
                @if (!parent.readonly?.()) {
                  <sd-button size="sm" theme="primary" (click)="onCreateItemButtonClick()">
                    <fa-icon [icon]="icons.add" [fixedWidth]="true" />
                    {{ insertText() }}
                    <small>(CTRL+INSERT)</small>
                  </sd-button>
                }
              }

              @for (toolControl of beforeToolControls(); track toolControl) {
                <ng-template [ngTemplateOutlet]="toolControl.contentTemplateRef()" />
              }

              @if (!parent.selectMode()) {
                @if (parent.toggleDeleteItems) {
                  <sd-button
                    size="sm"
                    theme="link-danger"
                    (click)="onToggleDeleteItemsButtonClick(true)"
                    [disabled]="!parent.isSelectedItemsHasNotDeleted()"
                  >
                    <fa-icon [icon]="icons.eraser" [fixedWidth]="true" />
                    선택 {{ deleteText() }}
                  </sd-button>
                  @if (parent.isSelectedItemsHasDeleted()) {
                    <sd-button
                      size="sm"
                      theme="link-warning"
                      (click)="onToggleDeleteItemsButtonClick(false)"
                    >
                      <fa-icon [icon]="icons.redo" [fixedWidth]="true" />
                      선택 복구
                    </sd-button>
                  }
                }

                @if (parent.uploadExcel) {
                  <sd-button size="sm" theme="link-success" (click)="onUploadExcelButtonClick()">
                    <fa-icon [icon]="icons.upload" [fixedWidth]="true" />
                    엑셀 업로드
                  </sd-button>
                }
              }

              @if (parent.downloadExcel) {
                <sd-button size="sm" theme="link-success" (click)="onDownloadExcelButtonClick()">
                  <fa-icon [icon]="icons.fileExcel" [fixedWidth]="true" />
                  엑셀 다운로드
                </sd-button>
              }

              @for (toolControl of afterToolControls(); track toolControl) {
                <ng-template [ngTemplateOutlet]="toolControl.contentTemplateRef()" />
              }
            </div>
          </sd-dock>

          <sd-pane>
            <sd-sheet
              [key]="parent.key + '-sheet'"
              [items]="parent.items()"
              [(currentPage)]="parent.page"
              [totalPageCount]="parent.pageLength()"
              [(sorts)]="parent.sortingDefs"
              [selectMode]="(parent.selectMode() ?? parent.toggleDeleteItems) ? 'multi' : undefined"
              [autoSelect]="parent.selectMode() === 'single' ? 'click' : undefined"
              [(selectedItems)]="parent.selectedItems"
              [trackByFn]="parent.trackByFn"
              [getItemCellStyleFn]="parent.getItemCellStyleFn"
            >
              @for (columnControl of columnControls(); track columnControl.key()) {
                <sd-sheet-column
                  [key]="columnControl.key()"
                  [fixed]="columnControl.fixed()"
                  [header]="columnControl.header()"
                  [headerStyle]="columnControl.headerStyle()"
                  [tooltip]="columnControl.tooltip()"
                  [width]="columnControl.width()"
                  [disableSorting]="columnControl.disableSorting()"
                  [disableResizing]="columnControl.disableResizing()"
                  [hidden]="columnControl.hidden()"
                  [collapse]="columnControl.collapse()"
                >
                  @if (columnControl.headerTemplateRef()) {
                    <ng-template #header>
                      <ng-template [ngTemplateOutlet]="columnControl.headerTemplateRef()!" />
                    </ng-template>
                  }
                  @if (columnControl.summaryTemplateRef()) {
                    <ng-template #summary>
                      <ng-template [ngTemplateOutlet]="columnControl.summaryTemplateRef()!" />
                    </ng-template>
                  }

                  <ng-template
                    [cell]="parent.items()"
                    let-item
                    let-index="index"
                    let-depth="depth"
                    let-edit="edit"
                  >
                    @if (parent.editItem && columnControl.edit() && !parent.readonly?.()) {
                      <sd-anchor
                        class="flex-row"
                        (click)="onEditItemButtonClick(item, index, $event)"
                      >
                        <div class="p-xs-sm pr-0">
                          <fa-icon [icon]="icons.edit" [fixedWidth]="true" />
                        </div>
                        <div class="flex-grow">
                          <ng-template
                            [ngTemplateOutlet]="columnControl.cellTemplateRef()"
                            [ngTemplateOutletContext]="{
                              $implicit: item,
                              item: item,
                              index: index,
                              depth: depth,
                              edit: edit,
                            }"
                          />
                        </div>
                      </sd-anchor>
                    } @else {
                      <ng-template
                        [ngTemplateOutlet]="columnControl.cellTemplateRef()"
                        [ngTemplateOutletContext]="{
                          $implicit: item,
                          item: item,
                          index: index,
                          depth: depth,
                          edit: edit,
                        }"
                      />
                    }
                  </ng-template>
                </sd-sheet-column>
              }
            </sd-sheet>
          </sd-pane>
        </sd-dock-container>
      </ng-template>

      @if (parent.selectMode()) {
        <ng-template #modalBottom>
          <div
            class="p-sm-default bdt bdt-trans-light flex-row flex-gap-sm"
            style="justify-content: right"
          >
            <sd-button theme="danger" inline (click)="onCancelButtonClick()">
              {{ parent.selectMode() === "multi" ? "모두" : "선택" }}
              해제
            </sd-button>
            @if (parent.selectMode() === "multi") {
              <sd-button theme="primary" inline (click)="onConfirmButtonClick()">
                확인({{ parent.selectedItemKeys().length }})
              </sd-button>
            }
          </div>
        </ng-template>
      }
    </sd-base-container>
  `,
            }]
    }], null, { onRefreshCommand: [{
            type: HostListener,
            args: ["sdRefreshCommand"]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdDataSheetControl, { className: "SdDataSheetControl", filePath: "packages/sd-angular/src/advanced/sd-data-sheet/sd-data-sheet.control.ts", lineNumber: 270 }); })();
export class AbsSdDataSheet {
    //-- implement
    #sdToast;
    #sdSharedData;
    #sdFileDialog;
    #viewType;
    ngOnInit() {
        if (this.initFilter) {
            const filter = this.initFilter();
            this.filter.set(filter);
            this.lastFilter.set(ObjectUtils.clone(this.filter()));
        }
    }
    constructor() {
        //-- implement
        this.#sdToast = inject(SdToastProvider);
        this.#sdSharedData = inject(SdSharedDataProvider);
        this.#sdFileDialog = inject(SdFileDialogProvider);
        this.#viewType = useViewTypeSignal(() => this);
        this.viewType = input();
        this.currViewType = $computed(() => this.viewType() ?? this.#viewType());
        this.busyCount = $signal(0);
        this.initialized = $signal(false);
        this.close = output();
        this.selectMode = input();
        this.selectedItemKeys = model([]);
        this.items = $signal([]);
        this.summaryData = $signal({});
        this.selectedItems = $signal([]);
        this.trackByFn = (item) => this.getItemInfo(item).key;
        this.page = $signal(0);
        this.pageLength = $signal(0);
        this.sortingDefs = $signal([]);
        //-- search
        this.filter = $signal({});
        this.lastFilter = $signal({});
        //-- delete
        this.isSelectedItemsHasDeleted = $computed(() => this.selectedItems().some((item) => this.getItemInfo(item).isDeleted));
        this.isSelectedItemsHasNotDeleted = $computed(() => this.selectedItems().some((item) => !this.getItemInfo(item).isDeleted));
        this.getItemCellStyleFn = (item) => this.getItemInfo(item).isDeleted ? "text-decoration: line-through;" : undefined;
        setupCumulateSelectedKeys({
            items: this.items,
            selectMode: this.selectMode,
            selectedItems: this.selectedItems,
            selectedItemKeys: this.selectedItemKeys,
            keySelectorFn: (item) => this.trackByFn(item),
        });
        setupCloserWhenSingleSelectionChange({
            selectMode: this.selectMode,
            selectedItemKeys: this.selectedItemKeys,
            close: this.close,
        });
        effect(() => {
            this.page();
            this.lastFilter();
            this.sortingDefs();
            const reflected = reflectComponentType(this.constructor);
            const inputPropNames = reflected.inputs.map((item) => item.propName);
            for (const inputPropName of inputPropNames) {
                if (["viewType", "selectMode, selectedItemKeys"].includes(inputPropName))
                    continue;
                this[inputPropName]();
            }
            queueMicrotask(async () => {
                if (this.restricted?.()) {
                    this.initialized.set(true);
                    return;
                }
                this.busyCount.update((v) => v + 1);
                await this.#sdToast.try(async () => {
                    await this.#sdSharedData.wait();
                    await this.refresh();
                });
                this.busyCount.update((v) => v - 1);
                this.initialized.set(true);
            });
        });
    }
    doFilterSubmit() {
        this.page.set(0);
        this.lastFilter.set(ObjectUtils.clone(this.filter()));
    }
    doRefresh() {
        if (this.busyCount() > 0)
            return;
        if (this.restricted?.())
            return;
        this.lastFilter.$mark();
    }
    async refresh() {
        const result = await this.search({
            type: "sheet",
            lastFilter: this.lastFilter(),
            sortingDefs: this.sortingDefs(),
            page: this.page(),
        });
        this.items.set(result.items);
        this.pageLength.set(result.pageLength ?? 0);
        this.summaryData.set(result.summary ?? {});
        this.selectedItems.set(this.items().filter((item) => this.selectedItems().some((sel) => this.getItemInfo(sel).key === this.getItemInfo(item).key)));
    }
    //-- edit
    async doEditItem(item) {
        if (!this.editItem)
            return;
        const result = await this.editItem(item);
        if (!result)
            return;
        this.busyCount.update((v) => v + 1);
        await this.#sdToast.try(async () => {
            await this.refresh();
        });
        this.busyCount.update((v) => v - 1);
    }
    async doToggleDeleteItems(del) {
        if (!this.toggleDeleteItems)
            return;
        if (this.readonly?.())
            return;
        this.busyCount.update((v) => v + 1);
        await this.#sdToast.try(async () => {
            const result = await this.toggleDeleteItems(this.selectedItems(), del);
            if (!result)
                return;
            await this.refresh();
            this.#sdToast.success(`${del ? "삭제" : "복구"} 되었습니다.`);
        });
        this.busyCount.update((v) => v - 1);
    }
    //-- excel
    async doDownloadExcel() {
        if (!this.downloadExcel)
            return;
        this.busyCount.update((v) => v + 1);
        await this.#sdToast.try(async () => {
            const items = (await this.search({
                type: "excel",
                lastFilter: this.lastFilter(),
                sortingDefs: this.sortingDefs(),
            })).items;
            await this.downloadExcel(items);
        });
        this.busyCount.update((v) => v - 1);
    }
    async doUploadExcel() {
        if (!this.uploadExcel)
            return;
        if (this.readonly?.())
            return;
        const file = await this.#sdFileDialog.showAsync(false, "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
        if (!file)
            return;
        this.busyCount.update((v) => v + 1);
        await this.#sdToast.try(async () => {
            await this.uploadExcel(file);
            await this.refresh();
            this.#sdToast.success("엑셀 업로드가 완료 되었습니다.");
        });
        this.busyCount.update((v) => v - 1);
    }
    doModalConfirm() {
        this.close.emit({ selectedItemKeys: this.selectedItemKeys() });
    }
    doModalCancel() {
        this.close.emit({ selectedItemKeys: [] });
    }
    static { this.ɵfac = function AbsSdDataSheet_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || AbsSdDataSheet)(); }; }
    static { this.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: AbsSdDataSheet, inputs: { viewType: [1, "viewType"], selectMode: [1, "selectMode"], selectedItemKeys: [1, "selectedItemKeys"] }, outputs: { close: "close", selectedItemKeys: "selectedItemKeysChange" } }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(AbsSdDataSheet, [{
        type: Directive
    }], () => [], null); })();
//# sourceMappingURL=sd-data-sheet.control.js.map