import { ChangeDetectionStrategy, Component, input, model, ViewEncapsulation } from "@angular/core";
import { SdSelectControl } from "../../controls/sd-select-control";
import { SdSelectItemControl } from "../../controls/sd-select-item.control";
import { SdRangeControl } from "../../controls/sd-range.control";
import { SdTextfieldControl } from "../../controls/sd-textfield.control";
import { transformBoolean } from "../../utils/type-tramsforms";
import * as i0 from "@angular/core";
function SdDateRangePicker_Conditional_7_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-range", 6);
    i0.ɵɵtwoWayListener("fromChange", function SdDateRangePicker_Conditional_7_Template_sd_range_fromChange_0_listener($event) { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); i0.ɵɵtwoWayBindingSet(ctx_r1.from, $event) || (ctx_r1.from = $event); return i0.ɵɵresetView($event); })("toChange", function SdDateRangePicker_Conditional_7_Template_sd_range_toChange_0_listener($event) { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); i0.ɵɵtwoWayBindingSet(ctx_r1.to, $event) || (ctx_r1.to = $event); return i0.ɵɵresetView($event); });
    i0.ɵɵlistener("fromChange", function SdDateRangePicker_Conditional_7_Template_sd_range_fromChange_0_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.handleFromDateChanged()); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵtwoWayProperty("from", ctx_r1.from)("to", ctx_r1.to);
} }
function SdDateRangePicker_Conditional_8_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-textfield", 7);
    i0.ɵɵtwoWayListener("valueChange", function SdDateRangePicker_Conditional_8_Template_sd_textfield_valueChange_0_listener($event) { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(); i0.ɵɵtwoWayBindingSet(ctx_r1.from, $event) || (ctx_r1.from = $event); return i0.ɵɵresetView($event); });
    i0.ɵɵlistener("valueChange", function SdDateRangePicker_Conditional_8_Template_sd_textfield_valueChange_0_listener() { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.handleFromDateChanged()); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵproperty("type", ctx_r1.periodType() === "\uC6D4" ? "month" : "date");
    i0.ɵɵtwoWayProperty("value", ctx_r1.from);
} }
export class SdDateRangePicker {
    constructor() {
        this.periodType = model("범위");
        this.from = model();
        this.to = model();
        this.required = input(false, { transform: transformBoolean });
    }
    handleDatePeriodTypeChanged() {
        if (this.periodType() === "월") {
            const fromDate = this.from();
            if (fromDate) {
                this.from.set(fromDate.setDay(1));
                this.to.set(fromDate.addMonths(1).setDay(1).addDays(-1));
            }
            else {
                this.to.set(undefined);
            }
        }
        else if (this.periodType() === "일") {
            this.to.set(this.from());
        }
    }
    handleFromDateChanged() {
        if (this.periodType() === "월") {
            const fromDate = this.from();
            this.to.set(fromDate?.addMonths(1).setDay(1).addDays(-1));
        }
        else if (this.periodType() === "일") {
            this.to.set(this.from());
        }
        else if (this.periodType() === "범위" &&
            this.from() &&
            this.to() &&
            this.from().tick > this.to().tick) {
            this.to.set(this.from());
        }
    }
    static { this.ɵfac = function SdDateRangePicker_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdDateRangePicker)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdDateRangePicker, selectors: [["sd-date-range-picker"]], inputs: { periodType: [1, "periodType"], from: [1, "from"], to: [1, "to"], required: [1, "required"] }, outputs: { periodType: "periodTypeChange", from: "fromChange", to: "toChange" }, decls: 9, vars: 2, consts: [["required", "", 2, "min-width", "0", 3, "valueChange", "value"], ["value", "\uC77C"], ["value", "\uC6D4"], ["value", "\uBC94\uC704"], ["type", "date", 3, "from", "to"], [3, "type", "value"], ["type", "date", 3, "fromChange", "toChange", "from", "to"], [3, "valueChange", "type", "value"]], template: function SdDateRangePicker_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-select", 0);
            i0.ɵɵtwoWayListener("valueChange", function SdDateRangePicker_Template_sd_select_valueChange_0_listener($event) { i0.ɵɵtwoWayBindingSet(ctx.periodType, $event) || (ctx.periodType = $event); return $event; });
            i0.ɵɵlistener("valueChange", function SdDateRangePicker_Template_sd_select_valueChange_0_listener() { return ctx.handleDatePeriodTypeChanged(); });
            i0.ɵɵelementStart(1, "sd-select-item", 1);
            i0.ɵɵtext(2, "\uC77C");
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(3, "sd-select-item", 2);
            i0.ɵɵtext(4, "\uC6D4");
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(5, "sd-select-item", 3);
            i0.ɵɵtext(6, "\uBC94\uC704");
            i0.ɵɵelementEnd()();
            i0.ɵɵconditionalCreate(7, SdDateRangePicker_Conditional_7_Template, 1, 2, "sd-range", 4)(8, SdDateRangePicker_Conditional_8_Template, 1, 2, "sd-textfield", 5);
        } if (rf & 2) {
            i0.ɵɵtwoWayProperty("value", ctx.periodType);
            i0.ɵɵadvance(7);
            i0.ɵɵconditional(ctx.periodType() === "\uBC94\uC704" ? 7 : 8);
        } }, dependencies: [SdSelectControl, SdSelectItemControl, SdRangeControl, SdTextfieldControl], styles: ["sd-date-range-picker{display:flex!important;flex-wrap:nowrap;flex-direction:row;gap:var(--gap-sm)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdDateRangePicker, [{
        type: Component,
        args: [{ selector: "sd-date-range-picker", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdSelectControl, SdSelectItemControl, SdRangeControl, SdTextfieldControl], template: `
    <sd-select
      [(value)]="periodType"
      (valueChange)="handleDatePeriodTypeChanged()"
      required
      style="min-width: 0"
    >
      <sd-select-item value="일">일</sd-select-item>
      <sd-select-item value="월">월</sd-select-item>
      <sd-select-item value="범위">범위</sd-select-item>
    </sd-select>
    @if (periodType() === "범위") {
      <sd-range type="date" [(from)]="from" [(to)]="to" (fromChange)="handleFromDateChanged()" />
    } @else {
      <sd-textfield
        [type]="periodType() === '월' ? 'month' : 'date'"
        [(value)]="from"
        (valueChange)="handleFromDateChanged()"
      />
    }
  `, styles: ["sd-date-range-picker{display:flex!important;flex-wrap:nowrap;flex-direction:row;gap:var(--gap-sm)}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdDateRangePicker, { className: "SdDateRangePicker", filePath: "packages/sd-angular/src/advanced/sd-date-range-picker/sd-date-range-picker.ts", lineNumber: 47 }); })();
//# sourceMappingURL=sd-date-range-picker.js.map