import { TemplateRef } from "@angular/core";
import { IconDefinition } from "@fortawesome/fontawesome-svg-core";
import { SdItemOfTemplateContext } from "../../directives/sd-item-of.template-directive";
import { ISharedDataBase } from "./sd-shared-data.provider";
import { ISdSelectModal, TSdSelectModalInfo } from "../sd-data-sheet/sd-data-select-button.control";
import * as i0 from "@angular/core";
export declare class SdSharedDataSelectListControl<T extends ISharedDataBase<string | number>, TModal extends ISdSelectModal> {
    #private;
    protected readonly icons: import("../../providers/sd-angular-config.provider").ISdAngularIcon;
    selectedItem: import("@angular/core").ModelSignal<T | undefined>;
    canChangeFn: import("@angular/core").InputSignal<(item: T | undefined) => boolean | Promise<boolean>>;
    items: import("@angular/core").InputSignal<T[]>;
    selectedIcon: import("@angular/core").InputSignal<IconDefinition | undefined>;
    useUndefined: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    filterFn: import("@angular/core").InputSignal<((item: T, index: number) => boolean) | undefined>;
    modal: import("@angular/core").InputSignal<TSdSelectModalInfo<TModal> | undefined>;
    headerTemplateRef: import("@angular/core").Signal<TemplateRef<void> | undefined>;
    filterTemplateRef: import("@angular/core").Signal<TemplateRef<void> | undefined>;
    itemTemplateRef: import("@angular/core").Signal<TemplateRef<SdItemOfTemplateContext<T>> | undefined>;
    undefinedTemplateRef: import("@angular/core").Signal<TemplateRef<void> | undefined>;
    busyCount: import("../../utils/bindings/$signal").SdWritableSignal<number>;
    searchText: import("../../utils/bindings/$signal").SdWritableSignal<string | undefined>;
    pageItemCount: import("@angular/core").InputSignal<number | undefined>;
    page: import("../../utils/bindings/$signal").SdWritableSignal<number>;
    pageLength: import("@angular/core").Signal<number>;
    displayItems: import("@angular/core").Signal<T[]>;
    constructor();
    select(item: T | undefined): void;
    toggle(item: T | undefined): void;
    onModalButtonClick(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdSharedDataSelectListControl<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdSharedDataSelectListControl<any, any>, "sd-shared-data-select-list", never, { "selectedItem": { "alias": "selectedItem"; "required": false; "isSignal": true; }; "canChangeFn": { "alias": "canChangeFn"; "required": false; "isSignal": true; }; "items": { "alias": "items"; "required": true; "isSignal": true; }; "selectedIcon": { "alias": "selectedIcon"; "required": false; "isSignal": true; }; "useUndefined": { "alias": "useUndefined"; "required": false; "isSignal": true; }; "filterFn": { "alias": "filterFn"; "required": false; "isSignal": true; }; "modal": { "alias": "modal"; "required": false; "isSignal": true; }; "pageItemCount": { "alias": "pageItemCount"; "required": false; "isSignal": true; }; }, { "selectedItem": "selectedItemChange"; }, ["headerTemplateRef", "filterTemplateRef", "itemTemplateRef", "undefinedTemplateRef"], never, true, never>;
}
