import { ApplicationRef, createComponent, inject, Injectable, inputBinding, } from "@angular/core";
import { SdBusyContainerControl } from "../controls/sd-busy-container.control";
import { $signal } from "../utils/bindings/$signal";
import { $effect } from "../utils/bindings/$effect";
import * as i0 from "@angular/core";
export class SdBusyProvider {
    #appRef;
    #containerRef;
    get containerRef() {
        if (this.#containerRef == null) {
            const compRef = createComponent(SdBusyContainerControl, {
                environmentInjector: this.#appRef.injector,
                bindings: [
                    inputBinding("type", this.type),
                    inputBinding("busy", () => this.globalBusyCount() > 0),
                ],
            });
            compRef.location.nativeElement.style.position = "absolute";
            compRef.location.nativeElement.style.pointerEvents = "none";
            this.#appRef.attachView(compRef.hostView);
            this.#containerRef = compRef;
            document.body.appendChild(this.#containerRef.location.nativeElement);
        }
        return this.#containerRef;
    }
    constructor() {
        this.#appRef = inject(ApplicationRef);
        this.type = $signal("bar");
        this.globalBusyCount = $signal(0);
        $effect(() => {
            this.containerRef.location.nativeElement.style.pointerEvents =
                this.globalBusyCount() > 0 ? "auto" : "none";
        });
    }
    static { this.ɵfac = function SdBusyProvider_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdBusyProvider)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: SdBusyProvider, factory: SdBusyProvider.ɵfac, providedIn: "root" }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdBusyProvider, [{
        type: Injectable,
        args: [{ providedIn: "root" }]
    }], () => [], null); })();
//# sourceMappingURL=sd-busy.provider.js.map