import { ComponentRef, OutputEmitterRef, Type } from "@angular/core";
import { SdToastContainerControl } from "../controls/sd-toast-container.control";
import { TDirectiveInputSignals } from "../utils/types";
import * as i0 from "@angular/core";
export declare class SdToastProvider {
    #private;
    readonly alertThemes: import("../utils/bindings/$signal").SdWritableSignal<("info" | "success" | "warning" | "danger")[]>;
    readonly overlap: import("../utils/bindings/$signal").SdWritableSignal<boolean>;
    beforeShowFn?: (theme: "info" | "success" | "warning" | "danger") => void;
    get containerRef(): ComponentRef<SdToastContainerControl>;
    try<R>(fn: () => Promise<R>, messageFn?: (err: Error) => string): Promise<R | undefined>;
    try<R>(fn: () => R, messageFn?: (err: Error) => string): R | undefined;
    notify<T extends ISdToast<any>>(toast: ISdToastInput<T>): {
        open: import("../utils/bindings/$signal").SdWritableSignal<boolean>;
    };
    info(message: string, userProgress?: boolean): any;
    success(message: string, useProgress?: boolean): any;
    warning(message: string, useProgress?: boolean): any;
    danger(message: string, useProgress?: boolean): any;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdToastProvider, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SdToastProvider>;
}
export interface ISdToast<O> {
    close: OutputEmitterRef<O | undefined>;
}
export interface ISdToastInput<T extends ISdToast<any>, X extends keyof any = ""> {
    type: Type<T>;
    inputs: Omit<TDirectiveInputSignals<T>, X>;
}
