import { effect, untracked, } from "@angular/core";
export function $effect(arg1, arg2, arg3) {
    const conditions = arg1 instanceof Array ? arg1 : undefined;
    const fn = (typeof arg1 === "function" ? arg1 : arg2);
    const options = (typeof arg1 === "function" ? arg2 : arg3);
    if (conditions) {
        return effect(async (onCleanup) => {
            for (const sig of conditions) {
                sig();
            }
            await untracked(async () => {
                await fn(onCleanup);
            });
        }, options);
    }
    else {
        return effect((onCleanup) => fn(onCleanup), options);
    }
}
//# sourceMappingURL=$effect.js.map