import { Signal, WritableSignal } from "@angular/core";
export declare class SdExpandingManager<T> {
    #private;
    private readonly _options;
    constructor(_options: {
        items: Signal<T[]>;
        expandedItems: WritableSignal<T[]>;
        getChildrenFn: Signal<((item: T, index: number) => T[] | undefined) | undefined>;
        sort: (items: T[]) => T[];
    });
    flattedItems: Signal<T[]>;
    hasExpandable: Signal<boolean>;
    isAllExpanded: Signal<boolean>;
    toggleAll(): void;
    toggle(item: T): void;
    getIsVisible(item: T): boolean;
    getDef(item: T): ISdExpandItemDef<T>;
}
export interface ISdExpandItemDef<T> {
    item: T;
    parentDef: ISdExpandItemDef<T> | undefined;
    hasChildren: boolean;
    depth: number;
}
